#pragma once

#include <ostream>
#include <istream>
using namespace std;

class V3 {

  float xyz[3];
public:
  V3(float x, float y, float z);
  V3() {};
  V3 operator+(V3 op1);
  V3 operator-(V3 op1);
  float operator*(V3 op1); // dot
  V3 operator*(float scf); // times scalar
  V3 operator/(float scf); // divide by scalar
  V3 operator^(V3 op1); // cross
  float& operator[](int i);
  friend ostream& operator<<(ostream &ostr, V3 v);
  friend istream& operator>>(istream &istr, V3 &v);
  float Length();
  void SetFromColor(unsigned int color);
  unsigned int GetColor();
  V3 Normalized();
};

class AABB {
public:
  V3 corners[2];
  AABB();
  void AddPoint(V3 p);
  V3& operator[](int i) { return corners[i];};
};